import sys
import glob
import serial

def sample(id):
    ser.write(chr(id) + 's')
    reply = ser.read(2)
    if not reply:
        raise NameError('Node %i not found.' % id)
    if reply != chr(id) + 's':
        raise IOError('Invalid node reply: Expected %s, received %s.' %
            (chr(id) + 's', reply))
    return ser.readline()

################################################################################

if (len(sys.argv) >= 2):
    port = sys.argv[1]
else:
    try:
        port = glob.glob('/dev/tty.usbserial*')[0]
    except:
        print "No serial port found."
        sys.exit()
    print 'Using auto-detected port', port

try:
    ser = serial.Serial(port, 115200, timeout = 0.1)
    # Read characters until the input buffer is empty
    while ser.read():
        pass
except serial.serialutil.SerialException:
    print "Failed to open serial port."
    sys.exit()